
external g_type_init : unit -> unit = "g_type_init_stub"

let _ = 
  g_type_init ()

external from_file : string -> Sdlvideo.surface = "rsvg_pixbuf_from_file_mlstub"
external from_file_at_zoom : string -> x_zoom:float -> y_zoom:float -> Sdlvideo.surface 
    = "rsvg_pixbuf_from_file_at_zoom_mlstub"
external from_file_at_size : string -> width:int -> height:int -> Sdlvideo.surface 
    = "rsvg_pixbuf_from_file_at_size_mlstub"
external from_file_at_max_size : string -> max_width:int -> max_height:int -> Sdlvideo.surface 
    = "rsvg_pixbuf_from_file_at_max_size_mlstub"
external from_file_at_zoom_with_max : string -> x_zoom:float -> y_zoom:float -> max_width:int -> max_height:int -> Sdlvideo.surface 
    = "rsvg_pixbuf_from_file_at_zoom_with_max_mlstub"

type t
external new_handle : (int -> int -> int * int) -> t
    = "rsvg_handle_new_stub"
external free_handle : t -> unit
    = "rsvg_handle_free_stub"
let make size_cb =
  let h = new_handle size_cb in
  Gc.finalise free_handle h ;
  h
(* external reset : t -> unit = "rsvg_handle_init_stub" *)
(* external set_default_dpi : float -> unit = "rsvg_handle_set_default_dpi_stub" *)
(* external set_dpi : t -> float -> unit = "rsvg_handle_set_dpi_stub" *)
external close : t -> unit = "rsvg_handle_close_stub"
external get_surface : t -> Sdlvideo.surface = "rsvg_handle_get_pixbuf_stub"

external write : t -> string -> off:int -> len:int -> unit = "rsvg_handle_write_stub"

let write_channel h ic = 
  let buff_size = 1024 * 4 in
  let buff = String.create buff_size in
  let cnt = ref ~-1 in
  while !cnt <> 0 do
    cnt := input ic buff 0 buff_size ;
    if !cnt > 0
    then write h buff 0 !cnt
  done ;
  close h
