let init () = 
  Sdl.init ~auto_clean:true [`VIDEO] ;
  Sdlvideo.set_video_mode 256 256 []


let svgs = [
  "tetris1.svg" ; "tetris2.svg" ; 
  "tetris3.svg" ; "tetris4.svg" ; "tetris5.svg" ; ]

let display surfs = 
  let scr = Sdlvideo.get_video_surface () in
  let blackp = Sdlvideo.map_RGB scr Sdlvideo.black in
  List.iter
    (fun src ->
      Sdlvideo.fill_rect scr blackp ;
      Sdlvideo.blit_surface ~src ~dst:scr () ;
      Sdlvideo.update_rect scr ;
      Sdltimer.delay 500 )
    surfs

let do_stuff svgs =
  let surfs = List.map Rsvg.from_file svgs in
  display surfs

let size_cb w h = 
  (w, h)

let do_stuff_bis svgs =
  let surfs = List.map 
      (fun fname ->
	let ic = open_in fname in
	let h = Rsvg.make size_cb in
	Rsvg.write_channel h ic ;
	close_in ic ;
	Rsvg.get_surface h)
      svgs in
  display surfs

let _ = 
  let _ = init () in
  
  do_stuff svgs ;
  Sdltimer.delay 2000 ;
  prerr_endline "attention" ;
  Gc.full_major () ;
  prerr_endline "fini" ;

  do_stuff_bis svgs ;
  Sdltimer.delay 2000 ;
  prerr_endline "attention" ;
  Gc.full_major () ;
  prerr_endline "fini"
